
/* Headers */

#ifndef ns_Net_Topology_h
#define ns_Net_Topology_h

#include "net_object.h"

#include <list>

#include <algorithm>

#include <cstdlib>

using namespace std;

class Net_Topology
{
public:
	/* constructors */
	Net_Topology() { Net_Topology(0, 0, 0); };
	Net_Topology(int, int, int);

	/* destructor */
	~Net_Topology(){}

	/* access functions */
	int GetSize_of_list() const ;
	int Get_GGSN_id() { return GGSN_id; }
	int Node_is_GGSN(int);
	int Node_is_SGSN(int);
	int Node_is_RNC(int);
	int Node_is_UE(int);
	int Get_SGSN_from_RNC(int);
	int Get_SGSN_from_UE(int);
	int Get_RNC_from_UE(int);
	list<int> Get_all_UEs();
	list<int> Get_SGSNs_from_UEs(list <int>);
	list<int> Get_RNCs_from_UEs(list<int>, int);
	list<int> Get_UEs_under_RNC(list<int>, int);
	
	/* list control functions */
	void clear_list();
	void del_items_with_UE(int);
	void add_item(int, int, int);
	void print_all();

protected:
	list<Net_Object> net_list;
	int GGSN_id;
};

#endif // ns_Net_Topology_h
